unit MainUnit;
{ *************************************************
  *            FormRgn library 04.05.99           *
  *           written by Grigoriev Anton          *
  *                                               *
  *                  Demo program                 *
  ************************************************* }


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FormRgn, Menus, ExtCtrls;

type
  TClockForm = class(TForm)
    FormRegion1: TFormRegion;
    CaptionRegion1: TCaptionRegion;
    PopupMenu: TPopupMenu;
    ItemMove: TMenuItem;
    ItemMinimize: TMenuItem;
    N1: TMenuItem;
    ItemClose: TMenuItem;
    N2: TMenuItem;
    ItemTime: TMenuItem;
    SystemButton1: TSystemButton;
    SystemButton2: TSystemButton;
    SysBtnSet: TSystemButton;
    N3: TMenuItem;
    ItemAbout: TMenuItem;
    Timer: TTimer;
    procedure ItemCloseClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ItemTimeClick(Sender: TObject);
    procedure ItemMinimizeClick(Sender: TObject);
    procedure ItemMoveClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ItemAboutClick(Sender: TObject);
   private
    Present:TDateTime;
    ClockFace:TBitmap;
    procedure WMTimeChange(var Message:TMessage);message WM_TimeChange;
  end;

var
  ClockForm: TClockForm;

implementation

{$R *.DFM}
{$R ClkFace.RES}

procedure TClockForm.ItemCloseClick(Sender: TObject);
 begin
  Close
 end;

procedure TClockForm.FormPaint(Sender: TObject);
 var HAngle,MAngle:Extended;
     H,M,S,MS:Word;
     HS:array[0..2] of TPoint;
  begin
   with Canvas do
    begin
     Draw(0,0,ClockFace)
    end;
   Present:=Now;
   DecodeTime(Present,H,M,S,MS);
   HAngle:=((H mod 12)/6+M/360)*Pi;
   MAngle:=M/30*Pi;
   Canvas.Brush.Style:=bsSolid;
   HS[0].X:=Round(99+55*Sin(HAngle));
   HS[0].Y:=Round(129-55*Cos(HAngle));
   HS[1].X:=Round(99-8*Sin(HAngle));
   HS[1].Y:=Round(129+8*Cos(HAngle));
   HS[2].X:=Round(99+8*Cos(HAngle));
   HS[2].Y:=Round(129+8*Sin(HAngle));
   Canvas.Brush.Color:=clGray;
   Canvas.Polygon(HS);
   HS[2].X:=Round(99-8*Cos(HAngle));
   HS[2].Y:=Round(129-8*Sin(HAngle));
   Canvas.Brush.Color:=clSilver;
   Canvas.Polygon(HS);
   HS[0].X:=Round(99+80*Sin(MAngle));
   HS[0].Y:=Round(129-80*Cos(MAngle));
   HS[1].X:=Round(99-8*Sin(MAngle));
   HS[1].Y:=Round(129+8*Cos(MAngle));
   HS[2].X:=Round(99+4*Cos(MAngle));
   HS[2].Y:=Round(129+4*Sin(MAngle));
   Canvas.Brush.Color:=clGray;
   Canvas.Polygon(HS);
   HS[2].X:=Round(99-4*Cos(MAngle));
   HS[2].Y:=Round(129-4*Sin(MAngle));
   Canvas.Brush.Color:=clSilver;
   Canvas.Polygon(HS)
  end;

procedure TClockForm.FormCreate(Sender: TObject);
 begin
  Application.ShowHint:=True;
  ClockFace:=TBitmap.Create;
  ClockFace.LoadFromResourceName(HInstance,'ClockFace');
  ClockFace.Transparent:=True;
  ClockFace.TransparentMode:=tmAuto
 end;

procedure TClockForm.ItemTimeClick(Sender: TObject);
 begin
  WinExec('Control.exe TimeDate.cpl',SW_ShowNormal)
 end;

procedure TClockForm.ItemMinimizeClick(Sender: TObject);
 begin
  Application.Minimize
 end;

procedure TClockForm.ItemMoveClick(Sender: TObject);
 begin
  SendMessage(Handle,WM_SysCommand,SC_Move,-1)
 end;

procedure TClockForm.WMTimeChange;
 begin
  inherited;
  Repaint;
  Message.Result:=0
 end;

procedure TClockForm.TimerTimer(Sender: TObject);
 var H,M1,M2,S,MS:Word;
 begin
  DecodeTime(Present,H,M1,S,MS);
  DecodeTime(Now,H,M2,S,MS);
  if M1<>M2 then
   Repaint
 end;

procedure TClockForm.ItemAboutClick(Sender: TObject);
 begin
  ShowMessage('Demo program from FormRgn Delphi library, written by Grigoriev Anton'#13#10'      If it is interesting for you, e-mail me at duker@ipmt-hpm.ac.ru')
 end;

end.
